// -*- c++ -*-
#ifndef _vtkFooReader_h
#define _vtkFooReader_h

#include "vtkUnstructuredGridAlgorithm.h"
#include "vtkStreamingDemandDrivenPipeline.h"
#include "vtkStringArray.h"
#include <sys/stat.h>
#include <algorithm>      // for find_if()

class vtkStringArray;

class VTK_IO_EXPORT vtkFooReader : public vtkUnstructuredGridAlgorithm
{
public:
  static vtkFooReader *New();
  vtkTypeRevisionMacro(vtkFooReader,vtkUnstructuredGridAlgorithm);
  void PrintSelf(ostream& os, vtkIndent indent);
  vtkSetStringMacro(FileName);
  vtkGetStringMacro(FileName);
  int CanReadFile(const char* fname);

  // Description:
  // Get an array that contains all the file names.
  vtkGetObjectMacro(FileNames, vtkStringArray);

protected:
  vtkFooReader();
  ~vtkFooReader();
  int RequestInformation(vtkInformation *, vtkInformationVector **, vtkInformationVector *);
  int RequestData(vtkInformation *, vtkInformationVector **, vtkInformationVector *);
  char *FileName;

  vtkStringArray *FileNames;    // VTK array of files

private:
  vtkFooReader(const vtkFooReader&);
  void operator = (const vtkFooReader&);
};
#endif // _vtkFooReader_h
